﻿init python:
    from copy import copy
    class leveling:
        def __init__(self, level):
            self.level = 0
            self.exp = 0
            self.talents = 0
            self.used_talents = 0
            self.level_up(level)

        def got_exp(self, exp):
            self.exp += exp
            if self.exp > 99:
                self.exp -= 100
                self.level_up(1)

        def level_up(self, levels):
            for i in range(levels):
                self.level += 1
                self.talents += 10

    class stats:
        def __init__(self):
            self.health = 100
            self.mana = 40
            self.stamina = 100

            self.max_health = 100
            self.max_mana = 40
            self.max_stamina = 100

            self.strength = 5
            self.agility = 2

            self.is_alive = True

    class fighter_animation:
        def __init__(self, base):
            self.base = base
            self.animation = "idle"
            self.variation = None

    class spell:
        def __init__(self, name, info, icon):
            self.name = name
            self.info = info
            self.icon = icon
    class item:
        def __init__(self, name, info, icon):
            self.name = name
            self.info = info
            self.icon = icon

    class enemy(leveling, stats, fighter_animation):
        def __init__(self, name, base, level = 1):
            stats.__init__(self)
            leveling.__init__(self, level)
            fighter_animation.__init__(self, base)
            self.name = name
            self.action = None
            self.is_ai = True

    class player(leveling, stats):
        def __init__(self, name, level = 1, spells = None, items = None):
            stats.__init__(self)
            leveling.__init__(self, level)
            self.name = name
            self.is_ai = False

            self.spells = spells or []
            self.items = items or []


    class battle_class:
        def __init__(self, players, enemies):
            self.players = players
            self.enemies = enemies

            self.stat = "playing"
            self.active = self.players[0]
            self.active_index = 0
            self.winner = None
            self.hover_item = None
            self.chosen_item = None
            position_pool = [
                None,
                [(0, 60)],
                [(-100, 40), (100, 40)],
                [(-180, 40), (0, 60), (180, 40)],
                [(-300, 0), (-100, 40), (100, 40), (300, 0)],
                [(-360, 0), (-180, 40), (0, 60), (180, 40), (360, 0)],
            ]
            self.positions = position_pool[len(self.enemies)]


        def hover(self, item):
            self.hover_item = item
        def unhover(self):
            self.hover_item = None

        def next(self):
            self.stat = None
            all = self.players + self.enemies
            max = len(all) -1

            self.active_index += 1
            if self.active_index > max:
                self.active_index = 0
                
            self.active = all[self.active_index]
            
            if self.active.is_alive:
                return
            self.winner = self.check_for_wins()
            if not self.winner:
                self.next()
        def check_for_wins(self):
            enemies_alive = [i for i in self.enemies if i.is_alive]
            players_alive = [i for i in self.players if i.is_alive]
            if not len(enemies_alive):
                return "You win"
            if not len(enemies_alive):
                return "You lose"
            return False

        def attack(self):
            self.stat = "choose enemy"
            renpy.play("battle/move.ogg", "sound")
        def attack_enemy(self, enemy, n):
            x,y = self.positions[n]
            attack = self.active.strength
            if self.chosen_item:
                attack += 10
            enemy.health -= attack
            if enemy.health < 1:
                enemy.is_alive = False
                enemy.animation = "dead"
            self.stat = "waiting"
            floating_text(-attack, x, y)
            renpy.play("battle/Kick.ogg", "sound")
            self.hover_item = None
            self.chosen_item = None

        def spell(self):
            self.stat = "choose spell"
            renpy.play("battle/move.ogg", "sound")
        def set_spell(self, spell):
            self.chosen_item = spell
            self.hover_item = spell
            self.stat = "choose enemy"
            renpy.play("battle/move.ogg", "sound")

        def item(self):
            self.stat = "choose item"
            renpy.play("battle/move.ogg", "sound")
        def set_item(self, item):
            self.chosen_item = item
            self.hover_item = item
            self.stat = "choose enemy"
            renpy.play("battle/move.ogg", "sound")
        def escape(self):
            renpy.play("battle/move.ogg", "sound")
            pass
        def back(self):
            self.stat = None
            self.chosen_item = None
            self.hover_item = None
            renpy.play("battle/move.ogg", "sound")

        def ai(self):
            chance = random.randint(0,100)
            targets = [i for i in self.players if i.is_alive]
            if not len(targets):
                self.next()
                return
            target = random.choice(targets)
            attack = self.active.strength
            if chance < 70:
                floating_text(-attack, 720, -300)
                target.health -= attack
                renpy.play("battle/Swipe.ogg", "sound")
            else:
                floating_text(-attack*2, 720, -300)
                target.health -= attack*2
                renpy.play("battle/Throw.ogg", "sound")
            if target.health < 1:
                target.is_alive = False
                target.animation = "dead"
            self.next()

screen battle(players, enemies):
    modal True
    style_prefix "battle"
    default g = battle_class(
        players = players,
        enemies = enemies,
        )

    # Enemies
    for p,i in zip(g.positions, g.enemies):
        fixed fit_first True:
            align .5,.5 offset p
            add i.base:
                align .5,.5
                if i.animation == "idle":
                    at battle_idle
                elif i.animation == "dead":
                    at battle_dead
            if i == g.active:
                at battle_zoom(4)
            else:
                at battle_zoom(3)
            if i == g.hover_item:
                add "battle_arrow" align .5,.0 yoffset -96

    for p,i in zip(g.positions, g.enemies):
        fixed fit_first True:
            align .5,.8 offset p
            use battle_stats(enemy = i)

    # GUI
    frame:
        yfill True xsize 450 xalign .0
        background "#000"
    frame:
        yfill True xsize 450 xalign 1.0
        background "#000"
    frame:
        xysize 1056,1152
        background Frame("frame_mask", 64, 130)

    hbox:
        spacing 48 align .5,.5
        vbox:
            spacing 48
            frame:
                xysize 384,528
                if g.hover_item:
                    if type(g.hover_item) is enemy:
                        use battle_enemy_hover(g.hover_item)
                    elif type(g.hover_item) is spell:
                        use battle_spell_hover(g.hover_item)
                    elif type(g.hover_item) is item:
                        use battle_item_hover(g.hover_item)
                elif g.chosen_item:
                    if type(g.chosen_item) is spell:
                        use battle_spell_hover(g.chosen_item)
                    elif type(g.chosen_item) is item:
                        use battle_item_hover(g.chosen_item)


            frame:
                xysize 384,384
        null width 960
        vbox:
            spacing 48
            frame:
                xysize 384,384
                hbox:
                    align .5,.5
                    for i in g.players:
                        vbox:
                            align .5,.5
                            # add i.base  align .5,.5 at zoom(3, True)
                            use battle_stats(enemy = i, x_size = 350, is_player = True)
            frame:
                xysize 384,528
                if g.winner:
                    vbox:
                        align .5,.5 spacing 10
                        text g.winner
                        button:
                            text "Exit"
                            action Return(g.winner)

                elif g.active.is_ai:
                    timer 1 repeat True action Function(g.ai)
                    vbox:
                        align .5,.5 spacing 10
                        text "Enemies turn."

                elif g.stat == "choose enemy":
                    vbox:
                        align .5,.5 spacing 10
                        vbox:
                            align .5,.5 spacing 10 box_wrap_spacing 10 box_wrap True ymaximum 400
                            for n,i in enumerate(g.enemies):
                                button:
                                    add i.base
                                    action Function(g.attack_enemy, i, n)  keysym "{}".format(n+1)
                                    hovered Function(g.hover, i)
                                    unhovered Function(g.unhover)
                        button:
                            text "Return"
                            action Function(g.back)

                elif g.stat == "choose spell":
                    vbox:
                        align .5,.5 spacing 10
                        vbox:
                            align .5,.5 spacing 10 box_wrap_spacing 10 box_wrap True ymaximum 400
                            for n,i in enumerate(g.active.spells):
                                button:
                                    add i.icon
                                    action Function(g.set_spell, i)  keysym "{}".format(n+1)
                                    hovered Function(g.hover, i)
                                    unhovered Function(g.unhover)
                        if not len(g.active.spells):
                            text "No spells."
                        button:
                            text "Return"
                            action Function(g.back)

                elif g.stat == "choose item":
                    vbox:
                        align .5,.5 spacing 10
                        vbox:
                            align .5,.5 spacing 10 box_wrap_spacing 10 box_wrap True ymaximum 400
                            for n,i in enumerate(g.active.items):
                                button:
                                    add i.icon
                                    action Function(g.set_item, i)  keysym "{}".format(n+1)
                                    hovered Function(g.hover, i)
                                    unhovered Function(g.unhover)
                        if not len(g.active.items):
                            text "No items."
                        button:
                            text "Return"
                            action Function(g.back)

                elif g.stat == "waiting":
                    timer 1 repeat True action Function(g.next)

                else:
                    vbox:
                        align .5,.5 spacing 10
                        text "Choose your move."

                        button:
                            text "Attack"
                            action Function(g.attack) keysym "1"
                        button:
                            text "Spell"
                            action Function(g.spell) keysym "2"
                        button:
                            text "Items"
                            action Function(g.item) keysym "3"
                        button:
                            text "Escape"
                            action Function(g.escape) keysym "4"

screen battle_item_hover(item):
    vbox:
        align .5,.5 spacing 8
        add item.icon align .5,.5 at zoom(4,True)
        text item.name color "#ffaa00"
        text item.info

screen battle_spell_hover(spell):
    vbox:
        align .5,.5 spacing 8
        add spell.icon align .5,.5 at zoom(4,True)
        text spell.name color "#ffaa00"
        text spell.info

screen battle_enemy_hover(enemy, x_size = 260):
    vbox:
        align .5,.5 spacing 8
        add enemy.base align .5,.5 at zoom(4,True)
        text "Level: {}".format(enemy.level)
        text enemy.name color "#ffaa00"
        bar value enemy.health range enemy.max_health xysize (x_size,20) left_bar Frame("bar_health", 20, 10) right_bar Frame("bar_empty", 20, 10)
        bar value enemy.mana range enemy.max_mana xysize (x_size,20) left_bar Frame("bar_mana", 20, 10) right_bar Frame("bar_empty", 20, 10)
        bar value enemy.stamina range enemy.max_stamina xysize (x_size,20) left_bar Frame("bar_stamina", 20, 10) right_bar Frame("bar_empty", 20, 10)

screen battle_stats(enemy, x_size = 160, is_player = False):
    vbox:
        align .5,.5 spacing 8
        text "Level: {}".format(enemy.level)
        text enemy.name
        bar value enemy.health range enemy.max_health xysize (x_size,20) left_bar Frame("bar_health", 20, 10) right_bar Frame("bar_empty", 20, 10)
        bar value enemy.mana range enemy.max_mana xysize (x_size,20) left_bar Frame("bar_mana", 20, 10) right_bar Frame("bar_empty", 20, 10)
        bar value enemy.stamina range enemy.max_stamina xysize (x_size,20) left_bar Frame("bar_stamina", 20, 10) right_bar Frame("bar_empty", 20, 10)
        if is_player:
            bar value enemy.exp range 1000 xysize (x_size,20) left_bar Frame("bar_exp", 20, 10) right_bar Frame("bar_empty", 20, 10)

transform battle_zoom(z):
    nearest True
    ease .2 zoom z
transform battle_idle():
    nearest True subpixel True
    anchor (.5,1.0)
    parallel:
        ease .6 yzoom .9
        ease .6 yzoom 1.0
        repeat
    parallel:
        ease .8 xzoom 1.0
        ease .4 xzoom .9
        repeat
transform battle_dead():
    nearest True subpixel True
    anchor (.5,1.0)
    ease 1.6 yzoom .2



style battle_text:
    align (.5,.5)
style battle_button:
    align (.5,.5) padding (20,20)
    background Frame("frame_filled", 30,30)
style battle_frame:
    align (.5,.5) padding (20,20)
    background Frame("frame_filled", 30,30)

init:
    image frame_filled:
        Crop((0,0,32,32), "battle/gui.png")
        zoom 3 nearest True
    image frame_empty:
        Crop((32,0,32,32), "battle/gui.png")
        zoom 3 nearest True
    image battle_arrow:
        Crop((96,0,32,32), "battle/gui.png")
        zoom 3 nearest True
    image frame_mask:
        Crop((0,32,64,96), "battle/gui.png")
        zoom 3 nearest True

    image bar_health = Crop((64,32,32,16), "battle/gui.png")
    image bar_mana = Crop((64,48,32,16), "battle/gui.png")
    image bar_stamina = Crop((96,32,32,16), "battle/gui.png")
    image bar_exp = Crop((86,48,32,16), "battle/gui.png")
    image bar_empty = Crop((64,64,32,16), "battle/gui.png")

init:
    image item_1 = Crop((128,0,32,32), "battle/gui.png")
    image item_2 = Crop((160,0,32,32), "battle/gui.png")
    image item_3 = Crop((192,0,32,32), "battle/gui.png")
    image item_4 = Crop((224,0,32,32), "battle/gui.png")
    image item_5 = Crop((128,32,32,32), "battle/gui.png")
    image item_6 = Crop((160,32,32,32), "battle/gui.png")

    image spell_1 = Crop((128,64,32,32), "battle/gui.png")
    image spell_2 = Crop((160,64,32,32), "battle/gui.png")
    image spell_3 = Crop((192,64,32,32), "battle/gui.png")
    image spell_4 = Crop((224,64,32,32), "battle/gui.png")

init:
    image enemy_1 = Crop((0,0,64,64), "battle/sprites.png")
    image enemy_2 = Crop((64,0,64,64), "battle/sprites.png")
    image enemy_3 = Crop((128,0,64,64), "battle/sprites.png")
    image enemy_4 = Crop((192,0,64,64), "battle/sprites.png")

    image enemy_5 = Crop((0,64,64,64), "battle/sprites.png")
    image enemy_6 = Crop((64,64,64,64), "battle/sprites.png")
    image enemy_7 = Crop((128,64,64,64), "battle/sprites.png")
    image enemy_8 = Crop((192,64,64,64), "battle/sprites.png")

    image enemy_9 = Crop((0,128,64,64), "battle/sprites.png")
    image enemy_10 = Crop((64,128,64,64), "battle/sprites.png")
    image enemy_11 = Crop((128,128,64,64), "battle/sprites.png")
    image enemy_12 = Crop((192,128,64,64), "battle/sprites.png")

    image enemy_13 = Crop((0,192,64,64), "battle/sprites.png")
    image enemy_14 = Crop((64,192,64,64), "battle/sprites.png")
    image enemy_15 = Crop((128,192,64,64), "battle/sprites.png")
    image enemy_16 = Crop((192,192,64,64), "battle/sprites.png")

# Let's define a player
default player_1 = player(
    name = "Me",
    level = 4,
    spells = [ # Give him some spells
        spell("FireBall", "It burns for 22 fire damage.", "spell_1"),
        spell("Poison Slash", "Poisons for 12 damage.", "spell_2"),
        spell("Courage Flame", "Revitalizes for 32 health.", "spell_3"),
        spell("Smite", "Smite for 44 damage.", "spell_4"),
        ],
    items = [ # And some items
        spell("Gold bar", "Pretty heavy, throw it.", "item_1"),
        spell("Horseshoe", "Pretty heavy, throw it.", "item_2"),
        spell("Health potion", "Tastes like beer.", "item_3"),
        spell("Venom", "Pretty potent.", "item_4"),
        spell("Axe", "Can be thrown.", "item_5"),
        spell("Hammer", "It can be thrown as well.", "item_6"),
        ],
    )

init: # and a pool of enemies
    default Magiple = enemy("Magiple", "enemy_1", 1)
    default Devix = enemy("Devix", "enemy_2", 1)
    default Vomidori = enemy("Vomidori", "enemy_3", 1)
    default Pdull = enemy("Pdull", "enemy_4", 1)
    default Waabird = enemy("Waabird", "enemy_5", 1)
    default Highgrape = enemy("Highgrape", "enemy_6", 1)
    default Lohigh = enemy("Lohigh", "enemy_7", 1)
    default Skulito = enemy("Skulito", "enemy_8", 1)
    default Execed = enemy("Execed", "enemy_9", 1)
    default Permy = enemy("Permy", "enemy_10", 1)
    default Bottolu = enemy("Bottolu", "enemy_11", 1)
    default Hurtface = enemy("Hurtface", "enemy_12", 1)
    default Sunreese = enemy("Sunreese", "enemy_13", 1)
    default Bulkish = enemy("Bulkish", "enemy_14", 1)
    default Iggygy = enemy("Iggygy", "enemy_15", 1)
    default Eyepie = enemy("Eyepie", "enemy_16", 1)
    default all_enemies = [
        Magiple, Devix, Vomidori, Pdull, Waabird, Highgrape, Lohigh, Skulito,
        Execed, Permy, Bottolu, Hurtface, Sunreese, Bulkish, Iggygy, Eyepie,
    ]

label battle_example:
    # Give the player som power
    $ player_1.strength = 18
    show bg jungle with dissolve
    "Let's start you with something easy."
    call screen battle([player_1], [copy(Vomidori)])
    "Now something a bit harder."
    python:
        fight_two_enemies = []
        for i in range(2):
            enemy = copy(random.choice(all_enemies))
            fight_two_enemies.append(enemy)
    call screen battle([player_1], fight_two_enemies)
    if _return == "You win":
        "That was close"
    else:
        "Too hard?"

label fight_loop:
    menu:
        "Revive and heal":
            $ player_1.is_alive = True
            $ player_1.health = player_1.max_health
            "You're fully healed."
        "Try a random fight.":
            python:
                fight_two_enemies = []
                for i in range(random.randint(1,5)):
                    enemy = copy(random.choice(all_enemies))
                    fight_two_enemies.append(enemy)
            call screen battle([player_1], fight_two_enemies)
            if _return == "You win":
                "You won."
            else:
                "Too hard?"
    jump fight_loop